//---------------------------------------------------------------------------
#ifndef autasimH
#define autasimH
//---------------------------------------------------------------------------

#define MAXDS 6

class Tuzel;

typedef char Tjmeno[20];
typedef char TcisSilnice[10];

struct Tpos
{
 int x,y;
 operator==(Tpos &p2){ return x==p2.x && y==p2.y;};
 operator!=(Tpos &p2){ return x!=p2.x || y!=p2.y;};
};

class Tauto
{
 public:
  Tauto* nxt; //nsledujc auto
  int d;      //vzdlenost od pedchozho auta
  short X,Y,X2,Y2,X3,Y3; //souadnice na obrazovce (v bodech)
  int barva;
  int cil;  //slo cle, kam jede
  int smer; //odkud pijd ke kiovatce
  Tauto();
  void smaz();
};

struct Tzatacka
{
  Tzatacka *nxt;
  Tpos pos;     //souadnice ve mst (v metrech)
  double px,py; //posunut na dal pruhy
  Tzatacka(){};
  Tzatacka(Tpos p,Tzatacka* n):pos(p),nxt(n){};
};

struct Tsemafory
{
  Tsemafory* nxt;
  int id;          //slo stavu
  short interval;  //doba trvn v sekundch
  Tsemafory(){};
  Tsemafory(int i);
};

struct Tfronta
{
  Tauto *auta, **autok; //prvn a posledn auto ve front
  Tauto *auton;   //nov auto, co pijelo ped zpracovnm fronty
  Tauto *autol;   //nsledujc auta jedou plynule bez brdn
  int dk;         //vzdlenost za poslednm
  Tfronta():auta(0),autok(&auta),auton(0),autol(0){};
  ~Tfronta();
};

class Tsilnice
{
 public:
  Tuzel *uzel;    //Parent
  Tsilnice* opac; //opan smr silnice
  short delodboc; //dlka vtven ped kiovatkou, pro vstup/park. je zde 0
  short pruhu0;   //poet pruh silnice
  short rychlost; // 3= 50km/h
  Tsilnice *nxt;
  Tsilnice **pre; //pro Dijkstra
  Tzatacka* zatacky; //seznam zatek

  bool selected;
  Tfronta* fronty;//ukaz. do pole front, nejdv silnice, pak vtven
  int delka;      //celkov dlka silnice v metrech
  int t;          //pro Dijkstra, pi simulaci poad zpracovn

  Tsilnice(Tuzel *);
  ~Tsilnice();
  Tzatacka * getZatac();
  void spoctiZatac(int b); //spote px,py v zatkch, pi b=0 oba smry
  void zruszatac();   //odstran vechny mal zatky
  int spoctidelku();  //dlka prostedku silnice
  int delkaP(int m);  //dlka m-tho pruhu
  void paint();
  void paint2(); //oba smry
  void autapaint(); //zobraz auta
  void Save();
  void Load();
  int getSmer();
  __property int smer={read=getSmer};
};

class Tpruhy : public Tsilnice
{
 public:
  short pruhu[4]; //poty pruh: [1]=vpravo,[2]=rovn,[3]=vlevo
  bool lspolec,rspolec; //spolen pruh pro rovn a vlevo/vpravo
  __property int pruhu1={read=getPruhu1}; //poet pruh ped kiovatkou

  char *trasa; //pro pruhu0!=0 ukazuje na pole char[Dcile] se smry

  Tpruhy(Tuzel *);
  int getPruhu1();
};

#define KONEC 0
#define VSTUP 1
#define PARK 2
#define CIL 3
#define KRIZ 4
#define PRECHOD 8
#define SEMAF 12

class Tuzel
{
 public:
  Tsilnice *s[MAXDS];
  Tuzel *nxt;
  int Ds;  //stupe
  int typ; //vstup|parkovit|kiovatka|pomocn uzel
  Tpos pos;//souadnice (v metrech)

  int t;   //pro Dijkstra
  int tag; //slo cle (nejdv vstupy, pak parkovit), poad v souboru
  int R;   //polomr
  bool selected; //vybrn

  Tuzel();
  virtual ~Tuzel();
  virtual int paint();            //nakresl uzel
  virtual void spoctiR();         //velikost uzle
  virtual Tsilnice* pridejsmer(); //pid novou silnici
  virtual void ubersmer(int smer);//smae silnici uzel->s[smer]
  virtual void setrid();   //sead silnice proti smru hodin. ruiek
  virtual void start(){};  //sputn simulace
  double uhel(int smer);   //smrov hel silnice
  bool naZatac();          //pedln uzle stupn 2 na zatku
};

class Tkonec : public Tuzel
{
 public:
  Tkonec *nxt;

  Tkonec();
  ~Tkonec();
  virtual Tsilnice* pridejsmer();
};

class Tcil : public Tuzel
{
 public:
  Tjmeno jmeno;   //nzev
  short prijizdi; //mnostv projdjcch aut za minutu

  int prijelo,vyjelo;
  int Iprojede; //potadlo
  double u;     //pro setdn podle hlu od stedu mapy
  char *trasa;  //ukazuje na pole char[Dcile] se smry

  Tcil();
  virtual ~Tcil();
  virtual int paint(); //zobraz tak jmeno
  void start();
};

class Tvstup : public Tcil
{
 public:
  Tvstup *nxt;
  TcisSilnice cislo;

  Tvstup();
  ~Tvstup();
  virtual Tsilnice* pridejsmer();
};

class Tpark : public Tcil
{
 public:
  Tpark *nxt;
  short Mpark;  //velikost parkovit

  int parkaut;  //poet zaparkovanch aut

  Tpark();
  ~Tpark();
  void start();
  virtual void spoctiR();
};

class Tuzelsemaf : public Tuzel
{
 public:
  short caszmen0;   //zatek semafor (v sekundch)
  bool jesemaf;     //zapnuty semafory

  int caszmen;      //as pt zmny semafor
  unsigned volno;   //svtla na semaforech
  int projelo;      //kolik projelo aut od sputn simulace

  Tuzelsemaf();
  void paintSemaf();
};

class Tprechod : public Tuzelsemaf
{
 public:
  Tprechod *nxt;
  short chodci,auta,tlacitko; //doba zelen na semaforu (v sekundch)

  Tprechod();
  ~Tprechod();
  void start();
  virtual Tsilnice* pridejsmer();
  virtual void ubersmer(int smer);
};

class Tkriz : public Tuzelsemaf
{
 public:
  Tkriz *nxt;
  int hlavni;       //typ hlavn silnice
  bool viceurovn;   //vcerovov
  Tsemafory *semaf;//seznam semafor

  Tsemafory *stav;  //aktuln stav semafor
  unsigned jeauto;

  Tkriz();
  ~Tkriz();
  void start();
  void prohod(int smer);
  virtual void spoctiR();
  virtual Tsilnice* pridejsmer();
  virtual void ubersmer(int smer);
  virtual void setrid();
  Tpruhy** Gets(){ return (Tpruhy**)Tuzel::s;}
  __property Tpruhy **s={read=Gets};
};

struct TUsiln
{
 Tsilnice *c;
 TUsiln *nxt;
 TUsiln(Tsilnice *_c):c(_c){};
};

class TFormE : public TForm
{
 public:
 __fastcall TFormE(TComponent* Owner): TForm(Owner){};
  virtual void UpdateAll()=0;
  virtual void update(){};
};

class TFormInfo : public TFormE
{
 public:
 __fastcall TFormInfo(TComponent* Owner): TFormE(Owner){};
};

//---------------------------------------------------------------------------

//funkce
void startsim();
void resetsim();
void kroksim();
double vzdalenost(Tpos p1,Tpos p2);
void prekresli();
void zmenaR();
void UpdateForms();
void activMain();

//promnn
extern Tuzel* uzly;
extern Tkriz* krizovatky;
extern Tprechod* prechody;
extern Tkonec* konce;
extern Tvstup* vstupy;
extern Tpark* parkoviste;
extern Tsilnice* silnice;

extern Tuzel *seluzel;
extern Tkriz *selkriz;
extern Tvstup *selvstup;
extern Tpark *selpark;
extern Tprechod *selprechod;
extern TUsiln *selsiln;
extern Tauto *selauto;

extern bool sim;
extern int cas;
extern bool modif;

extern int mapLeft,mapRight, mapTop,mapBottom;
extern Tfronta* Afronty;
extern int Dcile,Dfronty;
extern int Daut,Nvyjelo,Nprijelo;
extern Tauto *kos, *odjela;

//normln ka jzdnho pruhu (m)
#define DPRUHU 2.8
//---------------------------------------------------------------------------

#include "list1.h"

template <class T> inline T sqr(const T x)
{
 return x*x;
}

template <class T> inline void amin(T &a,T b)
{
 if(b>a) a=b;
}

template <class T> inline void amax(T &a,T b)
{
 if(b<a) a=b;
}

#if !defined( __MINMAX_DEFINED)
#define __MINMAX_DEFINED
template <class T> inline const T _FAR &min(const T _FAR &t1, const T _FAR &t2)
{
 if(t1<t2) return t1; else return t2;
}
template <class T> inline const T _FAR &max(const T _FAR &t1, const T _FAR &t2)
{
 if(t1>t2) return t1; else return t2;
}
#endif
//---------------------------------------------------------------------------
#endif
